import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Game here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Game extends World
{
    // The number of walls in the designed scene\\
              public int numWalls = 16;
    //------------------------------------------\\
    
    public Wall[] WallLibrary = new Wall[numWalls];
    /**
     * Constructor for objects of class Game.
     * 
     */
    public Game()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(800,600, 1); 
        
        /**
         * Here is a basic guide to the usage of 'Walls'.
         * There are 4 basic values to a wall,
         *   these are the x-y coordinate pairs of the two ends of a line.
         * These lines can then be shifted per a command, which takes in the wall, and a x-y shift.
         * This returns the augmented wall, allowing you to conviently design walls without having
         *   to work with offsets in the basic wall construction.
         * 
         * Here is an example:
         * 
         *   ShiftWall(new Wall(0,0,0,100),100,100)
         * 
         * This would create a vertical line, 100 pixels long, offset by 100 pixels
         *   to the right, and 100 pixels down.
         */
        addObject(new Camera(), 0, 0);
        WallLibrary[0] = ShiftWall(new Wall(0,0,0,50),100,100);
        WallLibrary[1] = ShiftWall(new Wall(0,0,0,50),100,150);
        WallLibrary[2] = ShiftWall(new Wall(0,0,0,50),100,50);
        WallLibrary[3] = ShiftWall(new Wall(0,0,50,0),100,50);
        WallLibrary[4] = ShiftWall(new Wall(0,0,50,0),150,50);
        WallLibrary[5] = ShiftWall(new Wall(0,0,50,0),200,50);
        WallLibrary[6] = ShiftWall(new Wall(0,0,50,0),100,200);
        WallLibrary[7] = ShiftWall(new Wall(0,0,50,0),150,200);
        WallLibrary[8] = ShiftWall(new Wall(0,0,50,0),200,200);
        WallLibrary[9] = ShiftWall(new Wall(0,0,0,50),250,50);
        WallLibrary[10] = ShiftWall(new Wall(0,0,0,50),250,100);
        WallLibrary[11] = ShiftWall(new Wall(0,0,0,50),250,150);
        WallLibrary[12] = ShiftWall(new Wall(0,0,0,50),150,100);
        WallLibrary[13] = ShiftWall(new Wall(0,0,50,0),150,100);
        WallLibrary[14] = ShiftWall(new Wall(0,0,0,50),200,100);
        WallLibrary[15] = ShiftWall(new Wall(0,0,50,0),150,150);
    }
    
    public Wall[] WallList()
    {
        return WallLibrary;
    }
    
     public Wall ShiftWall(Wall w,float x,float y)
    {
        w.x1 += x;
        w.x2 += x;
        w.y2 += y;
        w.y1 += y;
        return w;
    }
}
